#ifdef __WIN32__
#include <io.h>
#include <winsock.h>
#include <wininet.h>
#define SHUT_RDWR SD_BOTH
#else
#include <sys/socket.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <sys/stat.h>
#include <dirent.h>
#endif
#include "server.h"
#include "listdir.h"
#include "conn.h"
#include "utf8.h"
#include "debug.h"
#include <stdio.h>
#include <string.h>


int file_mtime(char* path, char* buf)
{
#ifdef __WIN32__
	struct _finddata_t filesx;
	int fhandle;
	fhandle = _findfirst(path, &filesx);
	if(fhandle == -1)
		return 1;
	strftime(buf, 24, "%Y%m%d%I%M%S", localtime(&filesx.time_write));
	_findclose(fhandle);
#else
	struct stat s;
	if (stat(path, &s) != 0)
		return 1;
	strftime(buf, 24, "%Y%m%d%I%M%S", localtime(&s.st_mtime));
#endif
	return 0;
}

int listdir(struct ftpconn* conn, char* dir)
{
	char tmp[13];
	char path[FULLPATH_LEN+6];
	int len, ret;
	DBG("listing %s", dir);
#ifdef __WIN32__
	struct _finddata_t filesx;
	int fhandle;
	sprintf(path, "%s/*.*", dir);
	fhandle = _findfirst(path, &filesx);
	if(fhandle == -1)
		return 1;
	do{
		if(filesx.name[0] == '.')
			continue;
		strftime(tmp, sizeof(tmp), "%b %d  %Y\0", localtime(&filesx.time_write));
		if(filesx.attrib & _A_SUBDIR)
			len = sprintf(conn->msgbuf, "drwxrwxrwx %04u %8s %8s %8lu %s %s\r\n", 
				1, "0", "0", filesx.size, tmp, filesx.name);
		else
			len = sprintf(conn->msgbuf, "-rwxrwxrwx %04u %8s %8s %8lu %s %s\r\n", 
				1, "0", "0", filesx.size, tmp, filesx.name);
		if(conn->opts_utf8)
			gb_to_utf8(conn->msgbuf, conn->msgbuf, sizeof(conn->msgbuf));
		ret = send(conn->dataconn_fd, conn->msgbuf, strlen(conn->msgbuf), 0);
		if(ret <= 0){
			DBG("send error: ret=%d", ret);
			break;
		}
	}while(!_findnext(fhandle,&filesx));
	_findclose(fhandle);
#else
	DIR* dir_info;
	struct dirent* dir_entry;
	dir_info = opendir(dir);
	int last_slash = 0;
	if( dir_info ){
		if (dir[strlen(dir)-1] == '/')
			last_slash = 1;
		while ( (dir_entry = readdir(dir_info)) != NULL)
		{
			struct stat s;
			if (dir_entry->d_name[0] == '.')
				continue;
			if( last_slash )
				snprintf(path, FULLPATH_LEN, "%s%s", dir, dir_entry->d_name);
			else
				snprintf(path, FULLPATH_LEN, "%s/%s", dir, dir_entry->d_name);
			if (stat(path, &s) == 0){
				strftime(tmp, sizeof(tmp), "%b %d  %Y\0", localtime(&s.st_mtime));
				if((s.st_mode&S_IFMT) == S_IFDIR)
					len = sprintf(conn->msgbuf, "drwxrwxrwx %04u %8s %8s %8lu %s %s\r\n", 
						1, "0", "0", s.st_size, tmp, dir_entry->d_name);
				else
					len = sprintf(conn->msgbuf, "-rwxrwxrwx %04u %8s %8s %8lu %s %s\r\n", 
						1, "0", "0", s.st_size, tmp, dir_entry->d_name);
				ret = send(conn->dataconn_fd, conn->msgbuf, len, 0);
				if(ret <= 0){
					DBG("send error: ret=%d", ret);
					break;
				}
			}
		} // while
		closedir(dir_info);
	}else{
		return 1;
	}
#endif
	return 0;
}

