#include <stdio.h>
#ifdef __WIN32__
#include <winsock.h>
#include <wininet.h>
#define SHUT_RDWR SD_BOTH
#else
#include <sys/socket.h>
#include <arpa/inet.h>
#endif
#include "debug.h"
#include "util.h"
#include "server.h"

struct ftpserver xxftpsrv;

int main(int argc, char **argv)
{
	int ret;
	debug_term_on();
	
	//init win32 socket
#ifdef __WIN32__
	static WSADATA wsa_data; 
	int result = WSAStartup((WORD)(1<<8|1), &wsa_data); //初始化WinSocket动态连接库
	if( result != 0 ) // 初始化失败
		return -1;
#endif

	if((ret = server_create(&xxftpsrv))){
		DBG("failed to create server, ret=%d", ret);
	}
	if((ret = server_start(&xxftpsrv))){
		DBG("failed to create server, ret=%d", ret);
	}
	
	/* boring spinning... */
	while(!xxftpsrv.server_end)
		SLEEP(1);

#ifdef __WIN32__
	WSACleanup();
#endif

	return 0;
}
