#ifndef _SERVER_H
#define _SERVER_H

#include <pthread.h>
#include <time.h>
#include "loop.h"
#include "util.h"

#define FULLPATH_LEN	1024
#define FILENAME_LEN	128

struct ftpip{
	unsigned int	ipnum;
	char			ipstr[32];
	unsigned short	cur_conns;
	struct ftpserver*	server;
};

struct ftpconn{
	int				conn_fd;
	time_t			time_create;
	time_t			time_alive;
	pthread_t		thread_conn;
	int				dataconn_fd;
	struct ftpserver*	server;
	struct ftpip*		ip;
	
	char			home_dir[FULLPATH_LEN+4];
	char			cur_dir[FULLPATH_LEN+4];
	char			full_path[FULLPATH_LEN+4];
	char			temp_path[FULLPATH_LEN+4];
	
	char			username[64+4];
	char			conn_end;
	char			msgbuf[KB(4)+4];
	char			identified;
	
	unsigned long	file_pos;
	char			opts_utf8;
	char			opts_pasv;
	char			port_ip[32];
	unsigned short	port_port;
	
	char			tempbuf[KB(2)+4];
	char			newpath[FULLPATH_LEN+4];
};

struct ftpdataconn{
	int				dataconn_fd;
	time_t			time_create;
	time_t			time_alive;
};

struct ftpserver{
	char			server_end;
	char			server_name[64];
	char			server_ip[32];
	unsigned short	server_port;
	char			server_root[256];
	
	int				server_fd;
	time_t			time_start;
	pthread_t		thread_guard;
	pthread_t		thread_listen;
	
	/* IP */
	loop			loop_ips;
	unsigned short	max_ips;
	unsigned short	cur_ips;
	
	/* Connection */
	loop			loop_conns;
	unsigned short	max_conns;
	unsigned short	cur_conns;
	
	unsigned short	max_conns_per_ip;
	unsigned short	conn_timeout;
	
	unsigned int	server_ipnum;
	
	unsigned short	reserved_ips;
	
	pthread_attr_t	thread_attr;
};

int	server_create(struct ftpserver* srv);
int server_start(struct ftpserver* srv);
int	server_stop(struct ftpserver* srv);

#endif //_SERVER_H
