#ifndef _UTIL_H
#define _UTIL_H

#include <unistd.h>

#ifndef KB
#define KB(a) (1024*(a))
#endif
#ifndef MB
#define MB(a) (1024*1024*(a))
#endif

#ifdef __WIN32__
#define SLEEP(a) _sleep(a*1000)
#else
#define closesocket close
#define stricmp strcasecmp
#define SLEEP(a) sleep(a)
#endif

typedef struct networkaddress{
	char		ip[32];
	unsigned short	port;
}networkaddress;

int parse_path( char* path );
int get_line( char* buf, int size, int* pos, char* line, int max );
char* http_ext_desc( char* ext );
char* http_code_string(int no);
void format_time(time_t t, char* buf);
int file_exists( const char* path, int* is_dir );
int mkdir_recursive( char* path );
void read_network_addr( networkaddress* srv, char* s, int* count, int max  );
struct sockaddr_in;
int netaddr_set( const char* name, struct sockaddr_in* addr );
int send_and_wait( int sock, char* p, int len );
int set_socket_nonblocking(int sock);
int def( const char* in, int in_len, char* out, int out_len );
int ftpmsg_format(int code, char* src, char* dst, int dest_len);

#endif
